import { __assign, __awaiter, __extends, __generator } from "tslib";
import { Transform } from "stream";
var EventSigningStream = (function (_super) {
    __extends(EventSigningStream, _super);
    function EventSigningStream(options) {
        var _this = _super.call(this, __assign({ autoDestroy: true, readableObjectMode: true, writableObjectMode: true }, options)) || this;
        _this.priorSignature = options.priorSignature;
        _this.eventSigner = options.eventSigner;
        _this.eventStreamCodec = options.eventStreamCodec;
        return _this;
    }
    EventSigningStream.prototype._transform = function (chunk, encoding, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var now, dateHeader, signature, serializedSigned, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        now = new Date();
                        dateHeader = {
                            ":date": { type: "timestamp", value: now },
                        };
                        return [4, this.eventSigner.sign({
                                payload: chunk,
                                headers: this.eventStreamCodec.formatHeaders(dateHeader),
                            }, {
                                priorSignature: this.priorSignature,
                                signingDate: now,
                            })];
                    case 1:
                        signature = _a.sent();
                        this.priorSignature = signature;
                        serializedSigned = this.eventStreamCodec.encode({
                            headers: __assign(__assign({}, dateHeader), { ":chunk-signature": {
                                    type: "binary",
                                    value: getSignatureBinary(signature),
                                } }),
                            body: chunk,
                        });
                        this.push(serializedSigned);
                        return [2, callback()];
                    case 2:
                        err_1 = _a.sent();
                        callback(err_1);
                        return [3, 3];
                    case 3: return [2];
                }
            });
        });
    };
    return EventSigningStream;
}(Transform));
export { EventSigningStream };
function getSignatureBinary(signature) {
    var buf = Buffer.from(signature, "hex");
    return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength / Uint8Array.BYTES_PER_ELEMENT);
}
